## adequate 0.7.1

=== doc/Makefile ===
version = $(word 2,$(shell cd .. && dpkg-parsechangelog | grep ^Version:))

.PHONY: all
all: adequate.1

tags.desc: ../adequate
	../private/update-tags

adequate.pod: adequate.podt tags.desc ../adequate
	../private/generate-manpage > $(@).tmp
	mv $(@).tmp $(@)

%.1: %.pod
	pod2man --utf8 -c '' -r "$(*) $(version)" $(<) $(@)

.PHONY: clean
clean:
	rm -f adequate.pod *.1 *.tmp

# vim:ts=4 sw=4 noet

=== tests/Makefile ===
.PHONY: all
all: adequate-testpkg_1_i386.changes
	$(info Run "make run" as root.)
	$(info Alternatively, if you have user-mode-linux installed, you can try "make run-uml" as normal user.)
	$(info )@:

adequate-testpkg_1_i386.changes:
	cd testpkg && dpkg-buildpackage -b -us -uc

.PHONY: run
run: adequate-testpkg_1_i386.changes
	./run-tests $(<)

.PHONY: run-uml
run-uml: adequate-testpkg_1_i386.changes
	fallocate -l 1G uml-guest-swap
	setsid linux init=$(CURDIR)/uml-guest-init \
		$(shell printf '%s' '$(CURDIR)' | base64 -w0 | tr = _) \
		$(shell printf '%s' '$(<)' | base64 -w0 | tr = _) \
		rootfstype=hostfs ubd0=uml-guest-swap mem=128M quiet con=null,fd:1 \
	| sed '/: adequate tests succeeded :/ q 100'; \
	[ $$? -eq 100 ]

.PHONY: clean
clean:
	cd testpkg && debian/rules clean
	rm -f *.changes *.deb
	rm -f uml-guest-swap

# vim:ts=4 sw=4 noet

## adequate 0.4.4

=== debian/changelog ===
adequate (0.4.4) unstable; urgency=low

  * Make sure that the APT hook won't fail when the package is removed but not
    purged (closes: #702904). Thanks to Andreas Beckmann for the bug report.

 -- Jakub Wilk <jwilk@debian.org>  Thu, 14 Mar 2013 17:50:28 +0100

adequate (0.4.3) unstable; urgency=low

  * Upload to unstable.

 -- Jakub Wilk <jwilk@debian.org>  Mon, 11 Mar 2013 22:30:21 +0100

adequate (0.4.2) experimental; urgency=low

  * Skip packages that are not fully installed (closes: #701995).
    Thanks to Axel Beckert for the bug report.
  * Refactor code responsible for printing errors and warnings.

 -- Jakub Wilk <jwilk@debian.org>  Sat, 02 Mar 2013 10:59:42 +0100

adequate (0.4.1) experimental; urgency=low

  * Update the package description.
  * Add description to the manual page.
  * Document --apt-preinst and --pending in more details.
  * Add a test suite.
    + Add DEP-8 test script.
  * Add README.source asking to change source format when forking.
  * Improve the pyshared-file-not-bytecompiled tag description.
  * Fix Python byte-compilation checks for Python < 2.6.
  * Fix Python byte-compilation checks for python-support < 0.90.
  * Improve error handling.

 -- Jakub Wilk <jwilk@debian.org>  Thu, 21 Feb 2013 13:41:14 +0100

adequate (0.4) experimental; urgency=low

  * Detect missing versioned symbols, too.
  * Avoid running ldd against the following files:
    - files that are known not to be readable;
    - dynamic linkers;
    - files with whitespace in their names.
  * Filter package names through dpkg-query. This adds or removes architecture
    suffixes, as needed.
  * Reduce number of ldd(1) calls to at most two.

  * Add option for chroot(2)ing into another directory: --root.
  * Add option for switching user and group: --user.
  * Make the APT hook run as user ‘nobody’.

  * Make the package more portable:
    + Stop requiring multi-arch-aware dpkg. Drop versioned runtime dependency
      on dpkg.
    + Stop using IPC::Run. Drop libipc-run-perl recommendation.
    + Load debconf modules lazily.

  * Improve options parsing. Exit with error for incompatible combinations of
    options (e.g. both --pending and --all).
  * Make --help more verbose.

  * Improve the documentation:
    + Work around bug #280148 in pod2man: manual page references should be
      rendered in bold, not in italics.
    + Add a to-do list.
    + Rewrite the undefined-symbol tag description.
    + Don't repeat “Debian Policy” if a tag refers multiple policy sections.
    + Document the --help option.
  * Replace “underlinked libraries” with “undefined symbols” in the package
    description. The latter is what adequate actually detects, while the
    former might or might not be the root cause of the observed problem.
  * Make generating the POD file atomic.

 -- Jakub Wilk <jwilk@debian.org>  Wed, 30 Jan 2013 23:46:24 +0100

adequate (0.3.1) experimental; urgency=low

  * Initial upload to Debian (closes: #698656).
  * Update years in debian/copyright.
  * Disable the APT hook. (It can be re-enabled by editing
    /etc/apt/apt.conf.d/20adequate).
  * Improve error handling.
  * Improve the documentation.
  * Rebuild the documentation from source.
  * Add Vcs-* and Homepage fields.

 -- Jakub Wilk <jwilk@debian.org>  Tue, 22 Jan 2013 23:30:21 +0100

adequate (0.3) unstable; urgency=low

  * Improve the documentation.
  * Remove some no-op code.
  * Check for undefined symbols.
  * Add libipc-run-perl to Recommends (needed for the new check).
  * Update the package description.
  * Bump standards version to 3.9.4 (no changes needed).

 -- Jakub Wilk <jwilk@debian.org>  Mon, 21 Jan 2013 20:25:37 +0100

adequate (0.2.1) unstable; urgency=low

  * Don't expect third-party Python 2.X modules to be byte-compiled if the
    corresponding Python version is not installed.
  * Print symlink target when reporting broken symlink.
  * Provide a manual page.

 -- Jakub Wilk <jwilk@debian.org>  Fri, 14 Sep 2012 17:32:13 +0200

adequate (0.2) unstable; urgency=low

  * Don't complain about .py files in /usr/lib/debug/usr/bin/ etc.
  * Don't complain about .py files in /usr/games/.
  * Check for /bin and /sbin binaries requiring /usr/lib libraries.
  * Reduce number of dpkg -L calls to one.

 -- Jakub Wilk <jwilk@debian.org>  Mon, 03 Sep 2012 20:27:04 +0200

adequate (0.1.1) unstable; urgency=low

  * Don't store ambiguous package names (for Multi-Arch: same packages) in
    /var/lib/adequate/pending.
  * Don't complain about .py files in /etc that are not byte-compiled.
  * Don't complain about .py files within standard libraries of alternative
    Python interpreters (jython, pypy) that are not byte-compiled.
  * Check byte-compilation of files in /usr/share/pyshared/ and
    /usr/share/python-support/.
  * Fix emitting messages longer than 2 lines via debconf.
  * Don't put colon between tag name and extra information.

 -- Jakub Wilk <jwilk@debian.org>  Sat, 11 Aug 2012 18:51:40 +0200

adequate (0.1) unstable; urgency=low

  * Initial release.

 -- Jakub Wilk <jwilk@debian.org>  Thu, 02 Aug 2012 21:19:14 +0200

=== debian/control ===
Source: adequate
Section: utils
Priority: optional
Maintainer: Jakub Wilk <jwilk@debian.org>
Build-Depends: debhelper (>= 7),
 python3 (>= 3.2), python3-apt
Standards-Version: 3.9.4
Vcs-Hg: https://bitbucket.org/jwilk/adequate
Vcs-Browser: https://bitbucket.org/jwilk/adequate
Homepage: http://jwilk.net/software/adequate

Package: adequate
Architecture: all
Depends: ${misc:Depends}, ${perl:Depends}, perl (>= 5.12), debconf
Description: Debian package quality testing tool
 adequate checks packages installed on the system and reports bugs and policy
 violations.
 .
 The following checks are currently implemented:
  * broken symlinks;
  * missing copyright file;
  * obsolete conffiles;
  * Python modules not byte-compiled;
  * /bin and /sbin binaries requiring /usr/lib libraries;
  * undefined symbols.

=== debian/rules ===
#!/usr/bin/make -f

.PHONY: clean
clean:
	$(MAKE) -C doc/ clean
	dh_testdir
	dh_clean

.PHONY: build build-arch build-indep
build: build-indep
build-indep:
	$(MAKE) -B -C doc/

.PHONY: binary binary-arch binary-indep

binary: binary-indep
binary-indep:
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs
	dh_install
	dh_installman doc/*.1
	dh_perl
	dh_installdocs
	dh_installchangelogs
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_gencontrol
	dh_md5sums
	dh_builddeb

# vim:ts=4 sw=4 noet

=== tests/testpkg/debian/rules ===
#!/usr/bin/make -f

tmp = debian/tmp
at = adequate-test

.PHONY: clean
clean:
	dh_clean

.PHONY: build
build: build-stamp

build-stamp:
	mkdir -p $(tmp)
	$(CC) lib.c -fPIC -shared -Wl,-soname,libadequate-lib.so.0 -o $(tmp)/libadequate-lib.so.0
	ln -sf libadequate-lib.so.0 $(tmp)/libadequate-lib.so
	$(CC) lib.c -fPIC -shared -Wl,-soname,libadequate-usrlib.so.0 -o $(tmp)/libadequate-usrlib.so.0
	ln -sf libadequate-usrlib.so.0 $(tmp)/libadequate-usrlib.so
	$(CC) prog.c -L$(tmp) -ladequate-lib -o $(tmp)/adequate-lib1
	cd $(tmp) && seq 2 5 | xargs -t -I {} ln -f adequate-lib1 adequate-lib{}
	$(CC) prog.c -L$(tmp) -ladequate-usrlib -o $(tmp)/adequate-usrlib1
	cd $(tmp) && seq 2 5 | xargs -t -I {} ln -f adequate-usrlib1 adequate-usrlib{}
	$(CC) -shared -Wl,--soname=lib$(at)-versioning.so.0 -Wl,--version-script=verscript-global lib.c -o $(tmp)/lib$(at)-versioning.so.0
	ln -sf lib$(at)-versioning.so.0 $(tmp)/lib$(at)-versioning.so
	$(CC) undef.c -fPIE -Wl,--unresolved-symbols,ignore-all -L$(tmp) -o $(tmp)/$(at)-us1
	$(CC) undef.c -fPIE -Wl,--unresolved-symbols,ignore-all -L$(tmp) -o $(tmp)/$(at)-us2 -l$(at)-versioning
	$(CC) -shared -Wl,--soname=lib$(at)-versioning.so.0 -Wl,--version-script=verscript-local lib.c -o $(tmp)/lib$(at)-versioning.so.0
	cp *.py debian/tmp/
	python2.7 -m compileall debian/tmp/
	touch $(@)

.PHONY: build-arch build-indep
build-arch build-indep:
	$(error $(@) is not implemented)

.PHONY: binary
binary:
	dh_install
	dh_installdocs -N adequate-testpkg-missing-copyright-file
	dh_installchangelogs
	dh_link
	dh_compress
	dh_fixperms
	dh_strip
	dh_makeshlibs
	dh_installdeb
	dh_gencontrol
	dh_md5sums
	dh_builddeb
	rm debian/adequate-testpkg-obsolete-conffile/etc/adequate/test-obsolete-conffile
	sed -i -e '/test-obsolete/d' debian/adequate-testpkg-obsolete-conffile/DEBIAN/conffiles
	dh_gencontrol -p adequate-testpkg-obsolete-conffile -- -v2
	dh_md5sums -p adequate-testpkg-obsolete-conffile
	dh_builddeb -p adequate-testpkg-obsolete-conffile

.PHONY: binary-arch binary-indep
binary-arch binary-indep:
	$(error $(@) is not implemented)

# vim:ts=4 sw=4 noet

=== debian/tests/control ===
Tests: adequate
Depends: adequate,
 build-essential, debhelper,
 python3 (>= 3.2), python3-apt,
 python2.7
Restrictions: breaks-testbed, needs-root

=== tests/testpkg/debian/control ===
Source: adequate-testpkg
Section: misc
Priority: extra
Maintainer: Jakub Wilk <jwilk@debian.org>
Build-Depends: debhelper (>= 7), python2.7
Standards-Version: 3.9.4

Package: adequate-testpkg-bin-or-sbin-binary-requires-usr-lib-library
Architecture: any
Description: adequate test package; do not install
  bin-or-sbin-binary-requires-usr-lib-library /bin/adequate-usrlib1 => /usr/lib/libadequate-usrlib.so.0
  bin-or-sbin-binary-requires-usr-lib-library /sbin/adequate-usrlib2 => /usr/lib/libadequate-usrlib.so.0

Package: adequate-testpkg-broken-symlink
Architecture: all
Description: adequate test package; do not install
  broken-symlink /usr/share/adequate/test-broken-symlink -> /this/file/does/not/exist

Package: adequate-testpkg-missing-copyright-file
Architecture: all
Description: adequate test package; do not install
  missing-copyright-file /usr/share/doc/adequate-testpkg-missing-copyright-file/copyright

Package: adequate-testpkg-obsolete-conffile
Architecture: all
Description: adequate test package; do not install
  obsolete-conffile /etc/adequate/test-obsolete-conffile

Package: adequate-testpkg-py-file-not-bytecompiled
Architecture: all
Depends: python2.7
Description: adequate test package; do not install
  py-file-not-bytecompiled /usr/lib/python2.7/dist-packages/adequate/test_no_pyc.py

Package: adequate-testpkg-pyshared-file-not-bytecompiled
Architecture: all
Description: adequate test package; do not install
  pyshared-file-not-bytecompiled /usr/share/pyshared/adequate/test_pyshared_no_pyc.py

Package: adequate-testpkg-undefined-symbol
Architecture: any
Description: adequate test package; do not install
  undefined-symbol /usr/bin/adequate-test-us1 => this_symbol_might_be_undefined
  undefined-symbol /usr/bin/adequate-test-us2 => this_symbol_might_be_undefined@ADEQUATE_TEST (libadequate-test-versioning.so.0)

## adequate 0.7.1

=== debian/changelog ===
adequate (0.7.1) unstable; urgency=low

  * When checking ELFs, skip unresolvable symlinks (closes: #709484, #716988).
    Thanks to Laurent Bonnaud and Peter Karbaliotis for the bug reports.

 -- Jakub Wilk <jwilk@debian.org>  Tue, 16 Jul 2013 15:37:13 +0200

adequate (0.7) unstable; urgency=low

  * Check if Python modules in /usr/lib/pypy/ are byte-compiled
    (closes: #710021).
  * Check for binaries linked to libraries with incompatible licenses.
    Currently only licenses of the following libraries are recognized:
    OpenSSL, GnuTLS, Poppler, and GNU Readline.
  * Remove a duplicate label.
    Thanks to Niels Thykier for the bug report.
  * Silence “skipping <pkgname> because it's not installed” warnings
    (closes: #712446).
    Thanks to Paul Wise for the bug report.
  * Add a section about reporting bugs to the manual page.
  * Update the package description.
  * Add “XS-Testsuite: autopkgtest”.

 -- Jakub Wilk <jwilk@debian.org>  Tue, 25 Jun 2013 00:25:26 +0200

adequate (0.6) unstable; urgency=low

  * Improve error handling when resolving symlinks (see bug #709484).
  * Improve error handling when accessing /var/lib/adequate/pending.
  * Add the --tags option (closes: #709372).
  * Assume that executable .py files in private directories that start with
    shebangs are scripts, rather than Python modules, and therefore don't
    require bytecompilation (closes: #709192).
  * Disable warnings about use of smartmatch (closes: #710063).
  * Add a minimal build-time test that verifies that adequate runs
    successfully and without warnings on a simple package (coreutils).
    + Add “perl (>= 5.12)” to Build-Depends.
  * Unset all LD_* environment variables when running ldd.

 -- Jakub Wilk <jwilk@debian.org>  Wed, 29 May 2013 22:25:59 +0200

adequate (0.5.3) unstable; urgency=low

  * Make the obsolete conffile check work with pre-multi-arch dpkg.
  * Don't consider a conffile obsolete if dpkg-query lists it as non-obsolete
    and belonging to a different package (closes: #708588). This is a
    work-around for dpkg bug #645849.
  * Don't complain about /usr/lib/pythonX.Y/__phello__.foo.py not being
    byte-compiled.
  * Don't complain about .py files in /usr/share/apport/package-hooks/ not
    being byte-compiled (closes: #709187).

 -- Jakub Wilk <jwilk@debian.org>  Tue, 21 May 2013 21:10:41 +0200

adequate (0.5.2) unstable; urgency=low

  * Don't use dh_testdir; instead, use makefile rules to ensure that
    debian/rules can be only run in the correct directory.
  * Whitelist ps_* symbols in libthread_db-*.so libraries when checking for
    undefined symbols.
  * Improve diagnostics when ldd fails (closes: #706915).
    Thanks to Paul Wise for the bug report.
  * Find more undefined versioned symbols.
  * Make --pending ignore dpkg-query exit code (closes: #707080). This is
    needed because packages listed in /var/lib/adequate/pending might have
    been removed in the mean time.
    Thanks to Paul Wise for the bug report.
  * Don't complain about missing .pyc in /usr/lib/python2.X/dist-packages/ if
    2.X is not a supported Python version (closes: #707614).
  * Don't complain about missing .pyc in /usr/lib/python3/dist-packages/ if
    no supported Python 3 version is installed.
  * Clean tests/ subdirectory in the clean target.

 -- Jakub Wilk <jwilk@debian.org>  Fri, 10 May 2013 12:39:39 +0200

adequate (0.5.1) unstable; urgency=low

  * Update the package description.
  * Disable the unicode_strings Perl feature.
  * Improve the manual page:
    + Call “Debian Python Policy” simply “Python Policy”.
    + Add links to Debian Policy and Python Policy.
    Thanks to Shirish Agarwal for the bug report.
  * Handle diversions correctly (closes: #706107).
    Thanks to Ben Hutchings for the bug report.
  * Fix Restrictions field in debian/tests/control. (The items should be
    space-separated, rather than comma-separated.)

 -- Jakub Wilk <jwilk@debian.org>  Wed, 24 Apr 2013 21:57:35 +0200

adequate (0.5) unstable; urgency=low

  * When looking for /(s)bin binaries, don't skip symlinks that point outside
    /(s)bin.
  * When looking for public executables and shared libraries, don't skip
    symlinks that point to directories that wouldn't normally be checked.
  * Check for binaries linked to libraries that cannot be found.
  * Change Debconf prompt priority to critical.

 -- Jakub Wilk <jwilk@debian.org>  Thu, 04 Apr 2013 22:09:12 +0200

=== debian/control ===
--- 
+++ 
@@ -3,11 +3,13 @@
 Priority: optional
 Maintainer: Jakub Wilk <jwilk@debian.org>
 Build-Depends: debhelper (>= 7),
+ perl (>= 5.12),
  python3 (>= 3.2), python3-apt
 Standards-Version: 3.9.4
 Vcs-Hg: https://bitbucket.org/jwilk/adequate
 Vcs-Browser: https://bitbucket.org/jwilk/adequate
 Homepage: http://jwilk.net/software/adequate
+XS-Testsuite: autopkgtest
 
 Package: adequate
 Architecture: all
@@ -22,4 +24,5 @@
   * obsolete conffiles;
   * Python modules not byte-compiled;
   * /bin and /sbin binaries requiring /usr/lib libraries;
-  * undefined symbols.
+  * missing libraries and undefined symbols;
+  * license conflicts.

=== tests/testpkg/debian/rules ===
--- 
+++ 
@@ -12,6 +12,7 @@
 
 build-stamp:
 	mkdir -p $(tmp)
+	# bin-or-sbin-binary-requires-usr-lib-library; library-not-found
 	$(CC) lib.c -fPIC -shared -Wl,-soname,libadequate-lib.so.0 -o $(tmp)/libadequate-lib.so.0
 	ln -sf libadequate-lib.so.0 $(tmp)/libadequate-lib.so
 	$(CC) lib.c -fPIC -shared -Wl,-soname,libadequate-usrlib.so.0 -o $(tmp)/libadequate-usrlib.so.0
@@ -20,11 +21,17 @@
 	cd $(tmp) && seq 2 5 | xargs -t -I {} ln -f adequate-lib1 adequate-lib{}
 	$(CC) prog.c -L$(tmp) -ladequate-usrlib -o $(tmp)/adequate-usrlib1
 	cd $(tmp) && seq 2 5 | xargs -t -I {} ln -f adequate-usrlib1 adequate-usrlib{}
+	# incompatible-licenses
+	$(CC) lib.c -fPIC -shared -Wl,-soname,libssl.so.1.0.0 -o $(tmp)/libssl.so
+	$(CC) lib.c -fPIC -shared -Wl,-soname,libreadline.so.6 -o $(tmp)/libreadline.so
+	$(CC) prog.c -L$(tmp) -lssl -lreadline -o $(tmp)/adequate-license-conflict
+	# undefined-symbol
 	$(CC) -shared -Wl,--soname=lib$(at)-versioning.so.0 -Wl,--version-script=verscript-global lib.c -o $(tmp)/lib$(at)-versioning.so.0
 	ln -sf lib$(at)-versioning.so.0 $(tmp)/lib$(at)-versioning.so
 	$(CC) undef.c -fPIE -Wl,--unresolved-symbols,ignore-all -L$(tmp) -o $(tmp)/$(at)-us1
 	$(CC) undef.c -fPIE -Wl,--unresolved-symbols,ignore-all -L$(tmp) -o $(tmp)/$(at)-us2 -l$(at)-versioning
 	$(CC) -shared -Wl,--soname=lib$(at)-versioning.so.0 -Wl,--version-script=verscript-local lib.c -o $(tmp)/lib$(at)-versioning.so.0
+	# adequate-testpkg-py-file-not-bytecompiled; adequate-testpkg-pyshared-file-not-bytecompiled
 	cp *.py debian/tmp/
 	python2.7 -m compileall debian/tmp/
 	touch $(@)

=== debian/tests/control ===
Tests: adequate
Depends: adequate,
 build-essential, debhelper,
 python3 (>= 3.2), python3-apt,
 python2.7
Restrictions: breaks-testbed needs-root

=== tests/testpkg/debian/control ===
--- 
+++ 
@@ -16,6 +16,16 @@
 Description: adequate test package; do not install
   broken-symlink /usr/share/adequate/test-broken-symlink -> /this/file/does/not/exist
 
+Package: adequate-testpkg-library-not-found
+Architecture: all
+Description: adequate test package; do not install
+  library-not-found /bin/adequate-lib1 => libadequate-lib.so.0
+
+Package: adequate-testpkg-incompatible-licenses
+Architecture: all
+Description: adequate test package; do not install
+  incompatible-licenses /usr/bin/adequate-license-conflict OpenSSL (libssl.so.1.0.0) + GPLv3+ (libreadline.so.6)
+
 Package: adequate-testpkg-missing-copyright-file
 Architecture: all
 Description: adequate test package; do not install
@@ -28,12 +38,13 @@
 
 Package: adequate-testpkg-py-file-not-bytecompiled
 Architecture: all
-Depends: python2.7
+Depends: python (>= 2.7), python (<< 2.8)
 Description: adequate test package; do not install
   py-file-not-bytecompiled /usr/lib/python2.7/dist-packages/adequate/test_no_pyc.py
 
 Package: adequate-testpkg-pyshared-file-not-bytecompiled
 Architecture: all
+Depends: python
 Description: adequate test package; do not install
   pyshared-file-not-bytecompiled /usr/share/pyshared/adequate/test_pyshared_no_pyc.py

## adequate 0.8.2

=== debian/changelog ===
adequate (0.8.2) unstable; urgency=low

  * Improve the manual page:
    + Fix hyphens used as minus signs.
    + Add examples (closes: #726152)
      Thanks to Shirish Agarwal for the bug report.
  * Don't complain about files in /usr/share/paster_templates/ not being
    byte-compiled.
  * Fix reporting incompatible-licenses, and other ELF-related tags, against
    wrong package (closes: #729031).
  * Fix incorrect implementation of --tags for ELF-related tags.

 -- Jakub Wilk <jwilk@debian.org>  Thu, 05 Dec 2013 10:04:22 +0100

adequate (0.8.1) unstable; urgency=medium

  * Fix possible privilege escalation via tty hijacking (CVE-2013-6409,
    closes: #730691).
    + Switch users only when running ldd.
    + Run ldd with stdin redirected to /dev/null, and without controlling
      terminal when run with reduced privileges.
  * Bump standards version to 3.9.5 (no changes needed).

 -- Jakub Wilk <jwilk@debian.org>  Thu, 28 Nov 2013 11:27:21 +0100

adequate (0.8) unstable; urgency=low

  * Summary of tag changes:
    + Added:
      - missing-symbol-version-information
      - symbol-size-mismatch

  * When printing warnings from ldd, avoid outputting binary name twice.
  * Check for symbol size mismatches.
  * Check for missing version information.
  * Report symbol issues with libraries in private directories (when they can
    be triggered by running ldd against binaries or libraries in public
    directories).
  * Add license information for libpoppler.so.37.
  * Don't complain about missing lua_* and luaL_* symbols in liblua* libraries.
  * Add “Summary of tag changes” sections to old changelog entries.

 -- Jakub Wilk <jwilk@debian.org>  Mon, 16 Sep 2013 13:27:06 +0200

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Build-Depends: debhelper (>= 7),
  perl (>= 5.12),
  python3 (>= 3.2), python3-apt
-Standards-Version: 3.9.4
+Standards-Version: 3.9.5
 Vcs-Hg: https://bitbucket.org/jwilk/adequate
 Vcs-Browser: https://bitbucket.org/jwilk/adequate
 Homepage: http://jwilk.net/software/adequate
@@ -24,5 +24,5 @@
   * obsolete conffiles;
   * Python modules not byte-compiled;
   * /bin and /sbin binaries requiring /usr/lib libraries;
-  * missing libraries and undefined symbols;
+  * missing libraries, undefined symbols, symbol size mismatches;
   * license conflicts.

=== tests/testpkg/debian/rules ===
--- 
+++ 
@@ -25,13 +25,23 @@
 	$(CC) lib.c -fPIC -shared -Wl,-soname,libssl.so.1.0.0 -o $(tmp)/libssl.so
 	$(CC) lib.c -fPIC -shared -Wl,-soname,libreadline.so.6 -o $(tmp)/libreadline.so
 	$(CC) prog.c -L$(tmp) -lssl -lreadline -o $(tmp)/adequate-license-conflict
+	# missing-version-information
+	$(CC) -shared -Wl,--soname=lib$(at)-versionless.so.0 -Wl,--version-script=verscript-global lib.c -o $(tmp)/lib$(at)-versionless.so.0
+	ln -sf lib$(at)-versionless.so.0 $(tmp)/lib$(at)-versionless.so
+	$(CC) undef.c -L$(tmp) -o $(tmp)/$(at)-msvi -l$(at)-versionless
+	$(CC) -shared -Wl,--soname=lib$(at)-versionless.so.0 lib.c -o $(tmp)/lib$(at)-versionless.so.0
+	# symbol-size-mismatch
+	$(CC) -shared -Wl,--soname=lib$(at)-symsize.so.0 lib.c -o $(tmp)/lib$(at)-symsize.so.0
+	ln -sf lib$(at)-symsize.so.0 $(tmp)/lib$(at)-symsize.so
+	$(CC) symsize.c -L$(tmp) -o $(tmp)/$(at)-symsize -l$(at)-symsize
+	$(CC) -shared -Wl,--soname=lib$(at)-symsize.so.0 -DADEQUATE_SYMBOL_SIZE=42 lib.c -o $(tmp)/lib$(at)-symsize.so.0
 	# undefined-symbol
 	$(CC) -shared -Wl,--soname=lib$(at)-versioning.so.0 -Wl,--version-script=verscript-global lib.c -o $(tmp)/lib$(at)-versioning.so.0
 	ln -sf lib$(at)-versioning.so.0 $(tmp)/lib$(at)-versioning.so
 	$(CC) undef.c -fPIE -Wl,--unresolved-symbols,ignore-all -L$(tmp) -o $(tmp)/$(at)-us1
-	$(CC) undef.c -fPIE -Wl,--unresolved-symbols,ignore-all -L$(tmp) -o $(tmp)/$(at)-us2 -l$(at)-versioning
+	$(CC) undef.c -L$(tmp) -o $(tmp)/$(at)-us2 -l$(at)-versioning
 	$(CC) -shared -Wl,--soname=lib$(at)-versioning.so.0 -Wl,--version-script=verscript-local lib.c -o $(tmp)/lib$(at)-versioning.so.0
-	# adequate-testpkg-py-file-not-bytecompiled; adequate-testpkg-pyshared-file-not-bytecompiled
+	# py-file-not-bytecompiled; pyshared-file-not-bytecompiled
 	cp *.py debian/tmp/
 	python2.7 -m compileall debian/tmp/
 	touch $(@)

=== tests/testpkg/debian/control ===
--- 
+++ 
@@ -31,6 +31,11 @@
 Description: adequate test package; do not install
   missing-copyright-file /usr/share/doc/adequate-testpkg-missing-copyright-file/copyright
 
+Package: adequate-testpkg-missing-symbol-version-information
+Architecture: all
+Description: adequate test package; do not install
+  missing-symbol-version-information /usr/bin/adequate-test-msvi => /usr/lib/libadequate-test-versionless.so.0
+
 Package: adequate-testpkg-obsolete-conffile
 Architecture: all
 Description: adequate test package; do not install
@@ -48,6 +53,11 @@
 Description: adequate test package; do not install
   pyshared-file-not-bytecompiled /usr/share/pyshared/adequate/test_pyshared_no_pyc.py
 
+Package: adequate-testpkg-symbol-size-mismatch
+Architecture: any
+Description: adequate test package; do not install
+  symbol-size-mismatch /usr/bin/adequate-test-symsize => this_symbol_size_varies
+
 Package: adequate-testpkg-undefined-symbol
 Architecture: any
 Description: adequate test package; do not install

## adequate 0.9.1ubuntu1

=== doc/Makefile ===
--- 
+++ 
@@ -11,7 +11,7 @@
 	mv $(@).tmp $(@)
 
 %.1: %.pod
-	pod2man --utf8 -c '' -r "$(*) $(version)" $(<) $(@)
+	pod2man --utf8 -c '' -q none -r "$(*) $(version)" $(<) $(@)
 
 .PHONY: clean
 clean:

=== tests/Makefile ===
--- 
+++ 
@@ -1,18 +1,21 @@
+arch = $(shell dpkg-architecture -qDEB_HOST_ARCH)
+changes = adequate-testpkg_1_$(arch).changes
+
 .PHONY: all
-all: adequate-testpkg_1_i386.changes
+all: $(changes)
 	$(info Run "make run" as root.)
 	$(info Alternatively, if you have user-mode-linux installed, you can try "make run-uml" as normal user.)
 	$(info )@:
 
-adequate-testpkg_1_i386.changes:
+$(changes):
 	cd testpkg && dpkg-buildpackage -b -us -uc
 
 .PHONY: run
-run: adequate-testpkg_1_i386.changes
+run: $(changes)
 	./run-tests $(<)
 
 .PHONY: run-uml
-run-uml: adequate-testpkg_1_i386.changes
+run-uml: $(changes)
 	fallocate -l 1G uml-guest-swap
 	setsid linux init=$(CURDIR)/uml-guest-init \
 		$(shell printf '%s' '$(CURDIR)' | base64 -w0 | tr = _) \

=== debian/changelog ===
adequate (0.9.1ubuntu1) trusty; urgency=medium

  * Merge with Debian unstable. Remaining Ubuntu changes:
    - debian/tests/control: Drop "breaks-testbed" restriction. Our
      "adt-virt-null in qemu" runner does not support that, but we want to run
      the test anyway.

 -- Martin Pitt <martin.pitt@ubuntu.com>  Thu, 19 Dec 2013 08:40:33 +0100

adequate (0.9.1) unstable; urgency=low

  * Update the package description.
  * Improve the test suite:
    + Fix Architecture fields of test packages.
    + Don't hardcode the i386 architecture (closes: #732448). Thanks to Martin
      Pitt for the bug report and the initial patch.
    + Fix DEP-8 test dependencies.
    + Fix test failures with ld that defaults to --as-needed. Thanks to Martin
      Pitt for the bug report and the patch.

 -- Jakub Wilk <jwilk@debian.org>  Wed, 18 Dec 2013 09:25:29 +0100

adequate (0.9) unstable; urgency=low

  * Summary of tag changes:
    + Added:
      - program-name-collision
      - missing-alternative

  * Add license information for libgmp.so.10 and libltdl.so.7.
  * Check for program name collisions.
  * Check if providers of x-terminal-emulator and x-window-manager register
    required alternatives.
  * Test runner: don't expect deterministic order of emitted tags.
  * Improve error handling.
  * Tidy up the code. Thanks, perlcritic.

 -- Jakub Wilk <jwilk@debian.org>  Mon, 16 Dec 2013 14:16:11 +0100

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: adequate
 Section: utils
 Priority: optional
-Maintainer: Jakub Wilk <jwilk@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Jakub Wilk <jwilk@debian.org>
 Build-Depends: debhelper (>= 7),
  perl (>= 5.12),
  python3 (>= 3.2), python3-apt
@@ -25,4 +26,6 @@
   * Python modules not byte-compiled;
   * /bin and /sbin binaries requiring /usr/lib libraries;
   * missing libraries, undefined symbols, symbol size mismatches;
-  * license conflicts.
+  * license conflicts;
+  * program name collisions;
+  * missing alternatives.

=== debian/rules ===
--- 
+++ 
@@ -1,21 +1,26 @@
 #!/usr/bin/make -f
 
 .PHONY: clean
-clean:
+clean: doc/Makefile tests/Makefile
 	$(MAKE) -C doc/ clean
-	dh_testdir
-	dh_clean
+	$(MAKE) -C tests/ clean
+	dh_clean debian/build-stamp
 
 .PHONY: build build-arch build-indep
 build: build-indep
-build-indep:
+build-indep: debian/build-stamp
+	
+debian/build-stamp: doc/Makefile adequate
 	$(MAKE) -B -C doc/
+ifeq "$(filter nocheck,$(DEB_BUILD_OPTIONS))" ""
+	./adequate coreutils 2>&1 | ( ! grep . )
+endif
+	touch $(@)
 
 .PHONY: binary binary-arch binary-indep
 
 binary: binary-indep
-binary-indep:
-	dh_testdir
+binary-indep: build-indep
 	dh_testroot
 	dh_prep
 	dh_installdirs

=== tests/testpkg/debian/rules ===
--- 
+++ 
@@ -17,14 +17,14 @@
 	ln -sf libadequate-lib.so.0 $(tmp)/libadequate-lib.so
 	$(CC) lib.c -fPIC -shared -Wl,-soname,libadequate-usrlib.so.0 -o $(tmp)/libadequate-usrlib.so.0
 	ln -sf libadequate-usrlib.so.0 $(tmp)/libadequate-usrlib.so
-	$(CC) prog.c -L$(tmp) -ladequate-lib -o $(tmp)/adequate-lib1
+	$(CC) prog.c -L$(tmp) -Wl,--no-as-needed -ladequate-lib -o $(tmp)/adequate-lib1
 	cd $(tmp) && seq 2 5 | xargs -t -I {} ln -f adequate-lib1 adequate-lib{}
-	$(CC) prog.c -L$(tmp) -ladequate-usrlib -o $(tmp)/adequate-usrlib1
+	$(CC) prog.c -L$(tmp) -Wl,--no-as-needed -ladequate-usrlib -o $(tmp)/adequate-usrlib1
 	cd $(tmp) && seq 2 5 | xargs -t -I {} ln -f adequate-usrlib1 adequate-usrlib{}
 	# incompatible-licenses
 	$(CC) lib.c -fPIC -shared -Wl,-soname,libssl.so.1.0.0 -o $(tmp)/libssl.so
 	$(CC) lib.c -fPIC -shared -Wl,-soname,libreadline.so.6 -o $(tmp)/libreadline.so
-	$(CC) prog.c -L$(tmp) -lssl -lreadline -o $(tmp)/adequate-license-conflict
+	$(CC) prog.c -L$(tmp) -Wl,--no-as-needed -lssl -lreadline -o $(tmp)/adequate-license-conflict
 	# missing-version-information
 	$(CC) -shared -Wl,--soname=lib$(at)-versionless.so.0 -Wl,--version-script=verscript-global lib.c -o $(tmp)/lib$(at)-versionless.so.0
 	ln -sf lib$(at)-versionless.so.0 $(tmp)/lib$(at)-versionless.so

=== debian/tests/control ===
Tests: adequate
Depends: adequate,
 build-essential, debhelper,
 python3 (>= 3.2), python3-apt,
 python (>= 2.7), python (<< 2.8)
Restrictions: needs-root
# originally had "breaks-testbed" too, but Ubuntu's "adt-virt-null in qemu"
# does not support that

=== tests/testpkg/debian/control ===
--- 
+++ 
@@ -17,14 +17,21 @@
   broken-symlink /usr/share/adequate/test-broken-symlink -> /this/file/does/not/exist
 
 Package: adequate-testpkg-library-not-found
-Architecture: all
+Architecture: any
 Description: adequate test package; do not install
   library-not-found /bin/adequate-lib1 => libadequate-lib.so.0
 
 Package: adequate-testpkg-incompatible-licenses
-Architecture: all
+Architecture: any
 Description: adequate test package; do not install
   incompatible-licenses /usr/bin/adequate-license-conflict OpenSSL (libssl.so.1.0.0) + GPLv3+ (libreadline.so.6)
+
+Package: adequate-testpkg-missing-alternative
+Architecture: all
+Provides: x-terminal-emulator, x-window-manager
+Description: adequate test package; do not install
+  missing-alternative x-terminal-emulator
+  missing-alternative x-window-manager
 
 Package: adequate-testpkg-missing-copyright-file
 Architecture: all
@@ -32,7 +39,7 @@
   missing-copyright-file /usr/share/doc/adequate-testpkg-missing-copyright-file/copyright
 
 Package: adequate-testpkg-missing-symbol-version-information
-Architecture: all
+Architecture: any
 Description: adequate test package; do not install
   missing-symbol-version-information /usr/bin/adequate-test-msvi => /usr/lib/libadequate-test-versionless.so.0
 
@@ -40,6 +47,11 @@
 Architecture: all
 Description: adequate test package; do not install
   obsolete-conffile /etc/adequate/test-obsolete-conffile
+
+Package: adequate-testpkg-program-name-collision
+Architecture: all
+Description: adequate test package; do not install
+  program-name-collision /usr/games/true /bin/true
 
 Package: adequate-testpkg-py-file-not-bytecompiled
 Architecture: all
@@ -61,5 +73,3 @@
 Package: adequate-testpkg-undefined-symbol
 Architecture: any
 Description: adequate test package; do not install
-  undefined-symbol /usr/bin/adequate-test-us1 => this_symbol_might_be_undefined
-  undefined-symbol /usr/bin/adequate-test-us2 => this_symbol_might_be_undefined@ADEQUATE_TEST (libadequate-test-versioning.so.0)

## adequate 0.11.3~bpo70+1

=== debian/changelog ===
adequate (0.11.3~bpo70+1) wheezy-backports; urgency=low

  * Rebuild for wheezy-backports.
  * Add myself to uploaders. 

 -- Holger Levsen <holger@debian.org>  Thu, 23 Jan 2014 19:23:19 +0100

adequate (0.11.3) unstable; urgency=medium

  * Brown paper bag release.
  * Fix false positive missing-alternative when there is more than one
    provider of the tested virtual package. Thanks to James McCoy for the bug
    report and the inital patch.
  * Add license information for libpoppler.so.43 (seen in Ubuntu).
  * Force gzip for tarball compression.
  * Bump minimum required version of Perl to 5.14.
    Perl 5.14 features have been used since adequate 0.10.

 -- Jakub Wilk <jwilk@debian.org>  Fri, 17 Jan 2014 19:15:40 +0100

adequate (0.11.2) unstable; urgency=low

  * Fix license information for GnuTLS.

 -- Jakub Wilk <jwilk@debian.org>  Sun, 12 Jan 2014 18:51:27 +0100

adequate (0.11.1) unstable; urgency=low

  * Brown paper bag release.
  * Fix false positive broken-binfmt-interpreter.
  * Tidy up the code. Thanks, perlcritic.

 -- Jakub Wilk <jwilk@debian.org>  Fri, 10 Jan 2014 15:31:08 +0100

adequate (0.11) unstable; urgency=low

  * Summary of tag changes:
    + Added:
      - broken-binfmt-detector
      - broken-binfmt-interpreter

  * Check for broken binfmt interpreters and detectors.
  * Update the package description.
  * Fix a typo in the manual page (closes: #734692).
    Thanks to Shirish Agarwal for the bug report.

 -- Jakub Wilk <jwilk@debian.org>  Thu, 09 Jan 2014 23:41:45 +0100

adequate (0.10) unstable; urgency=low

  * Don't strip architecture qualifiers when reporting missing copyright files
    in “Multi-Arch: same” packages.
  * Extract license information from machine-readable copyright files.
  * Don't complain about scripts in /usr/lib/pythonX.Y/config-*/ not being
    byte-compiled.
  * Don't complain about program name collisions between molly-guard and
    sysvinit(-core). Thanks to Thorsten Glaser for the bug report.
  * Don't complain about program name collision between safe-rm and coreutils.
  * Tidy up the code. Thanks, perlcritic.

 -- Jakub Wilk <jwilk@debian.org>  Fri, 27 Dec 2013 17:48:30 +0100

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,10 @@
 Source: adequate
 Section: utils
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Jakub Wilk <jwilk@debian.org>
+Maintainer: Jakub Wilk <jwilk@debian.org>
+Uploaders: Holger Levsen <holger@debian.org>
 Build-Depends: debhelper (>= 7),
- perl (>= 5.12),
+ perl (>= 5.14),
  python3 (>= 3.2), python3-apt
 Standards-Version: 3.9.5
 Vcs-Hg: https://bitbucket.org/jwilk/adequate
@@ -14,7 +14,7 @@
 
 Package: adequate
 Architecture: all
-Depends: ${misc:Depends}, ${perl:Depends}, perl (>= 5.12), debconf
+Depends: ${misc:Depends}, ${perl:Depends}, perl (>= 5.14), debconf
 Description: Debian package quality testing tool
  adequate checks packages installed on the system and reports bugs and policy
  violations.
@@ -28,4 +28,5 @@
   * missing libraries, undefined symbols, symbol size mismatches;
   * license conflicts;
   * program name collisions;
-  * missing alternatives.
+  * missing alternatives;
+  * missing binfmt interpreters and detectors.

=== debian/tests/control ===
Tests: adequate
Depends: adequate,
 build-essential, debhelper,
 python3 (>= 3.2), python3-apt,
 python (>= 2.7), python (<< 2.8)
Restrictions: breaks-testbed needs-root

## adequate 0.11.6~bpo70+1

=== debian/changelog ===
adequate (0.11.6~bpo70+1) wheezy-backports; urgency=medium

  * Rebuild for wheezy-backports.
  * Add myself to uploaders. 

 -- Holger Levsen <holger@debian.org>  Mon, 12 May 2014 08:28:00 +0000

adequate (0.11.6) unstable; urgency=medium

  * Fix a typo in the --help message.
  * Improve the test suite:
    + Don't use APT for package installation, but manually call dpkg. This
      greatly reduces memory usage and improves speed.
    + If a package installation failed, don't try to upgrade newer versions of
      the same package.
    + Improve error handling.
  * Fix license information for libgmp.

 -- Jakub Wilk <jwilk@debian.org>  Sun, 20 Apr 2014 20:06:53 +0200

adequate (0.11.5) unstable; urgency=low

  * DEP-8 tests: add a smoke test, which can be run without any restrictions.
  * Use the smoke test also at build time.
  * Add license information for libpoppler.so.44.
  * Update year range in the copyright file.

 -- Jakub Wilk <jwilk@debian.org>  Mon, 03 Mar 2014 13:44:14 +0100

adequate (0.11.4) unstable; urgency=low

  * Use dh-buildinfo.
  * Add the --version option. Thanks to Holger Levsen for the bug report.

 -- Jakub Wilk <jwilk@debian.org>  Sat, 25 Jan 2014 23:19:34 +0100

=== tests/testpkg/debian/rules ===
--- 
+++ 
@@ -25,6 +25,7 @@
 	$(CC) lib.c -fPIC -shared -Wl,-soname,libssl.so.1.0.0 -o $(tmp)/libssl.so
 	$(CC) lib.c -fPIC -shared -Wl,-soname,libreadline.so.6 -o $(tmp)/libreadline.so
 	$(CC) prog.c -L$(tmp) -Wl,--no-as-needed -lssl -lreadline -o $(tmp)/adequate-license-conflict
+	$(CC) prog.c -L$(tmp) -Wl,--no-as-needed -lreadline -o $(tmp)/adequate-license-conflict-dep5
 	# missing-version-information
 	$(CC) -shared -Wl,--soname=lib$(at)-versionless.so.0 -Wl,--version-script=verscript-global lib.c -o $(tmp)/lib$(at)-versionless.so.0
 	ln -sf lib$(at)-versionless.so.0 $(tmp)/lib$(at)-versionless.so

=== tests/testpkg/debian/control ===
--- 
+++ 
@@ -25,6 +25,11 @@
 Architecture: any
 Description: adequate test package; do not install
   incompatible-licenses /usr/bin/adequate-license-conflict OpenSSL (libssl.so.1.0.0) + GPLv3+ (libreadline.so.6)
+
+Package: adequate-testpkg-incompatible-licenses-dep5
+Architecture: any
+Description: adequate test package; do not install
+  incompatible-licenses /usr/bin/adequate-license-conflict-dep5 GPLv2 + GPLv3+ (libreadline.so.6)
 
 Package: adequate-testpkg-missing-alternative
 Architecture: all
@@ -68,8 +73,3 @@
 Package: adequate-testpkg-symbol-size-mismatch
 Architecture: any
 Description: adequate test package; do not install
-  symbol-size-mismatch /usr/bin/adequate-test-symsize => this_symbol_size_varies
-
-Package: adequate-testpkg-undefined-symbol
-Architecture: any
-Description: adequate test package; do not install

## adequate 0.12~bpo70+1

=== tests/Makefile ===
--- 
+++ 
@@ -17,12 +17,11 @@
 .PHONY: run-uml
 run-uml: $(changes)
 	fallocate -l 1G uml-guest-swap
-	setsid linux init=$(CURDIR)/uml-guest-init \
+	linux init=$(CURDIR)/uml-guest-init \
 		$(shell printf '%s' '$(CURDIR)' | base64 -w0 | tr = _) \
 		$(shell printf '%s' '$(<)' | base64 -w0 | tr = _) \
 		rootfstype=hostfs ubd0=uml-guest-swap mem=128M quiet con=null,fd:1 \
-	| sed '/: adequate tests succeeded :/ q 100'; \
-	[ $$? -eq 100 ]
+	| cat
 
 .PHONY: clean
 clean:

=== debian/changelog ===
adequate (0.12~bpo70+1) wheezy-backports; urgency=medium

  * Rebuild for wheezy-backports.
  * Add myself to uploaders. 

 -- Holger Levsen <holger@debian.org>  Wed, 06 Aug 2014 11:10:33 +0200

adequate (0.12) unstable; urgency=low

  * Exclude /usr/lib/pythonX.Y/lib2to3/tests/data/ and
    /usr/lib/pythonX.Y/test/bad* from byte-compilation checks.
  * Check for collisions between executables and bash builtin commands.
  * Use HTTPS URLs when they are available, in documentation and code.
  * Simplify error handling.
  * Test suite: fix compatibility with dpkg (>= 1.17.7).

 -- Jakub Wilk <jwilk@debian.org>  Mon, 07 Jul 2014 22:41:34 +0200

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Jakub Wilk <jwilk@debian.org>
 Uploaders: Holger Levsen <holger@debian.org>
-Build-Depends: debhelper (>= 7),
+Build-Depends: debhelper (>= 7), dh-buildinfo,
  perl (>= 5.14),
  python3 (>= 3.2), python3-apt
 Standards-Version: 3.9.5

=== tests/testpkg/debian/rules ===
--- 
+++ 
@@ -67,7 +67,10 @@
 	dh_builddeb
 	rm debian/adequate-testpkg-obsolete-conffile/etc/adequate/test-obsolete-conffile
 	sed -i -e '/test-obsolete/d' debian/adequate-testpkg-obsolete-conffile/DEBIAN/conffiles
-	dh_gencontrol -p adequate-testpkg-obsolete-conffile -- -v2
+	cp -f debian/files debian/files.orig
+	dh_gencontrol -p adequate-testpkg-obsolete-conffile -- -v2 -fdebian/files2
+	cat debian/files2 >> debian/files
+	rm -f debian/files2
 	dh_md5sums -p adequate-testpkg-obsolete-conffile
 	dh_builddeb -p adequate-testpkg-obsolete-conffile

=== debian/tests/control ===
--- 
+++ 
@@ -1,4 +1,7 @@
-Tests: adequate
+Tests: smoke-test
+Depends: adequate
+
+Tests: full-test
 Depends: adequate,
  build-essential, debhelper,
  python3 (>= 3.2), python3-apt,

=== tests/testpkg/debian/control ===
--- 
+++ 
@@ -56,6 +56,7 @@
 Package: adequate-testpkg-program-name-collision
 Architecture: all
 Description: adequate test package; do not install
+  program-name-collision /usr/games/true (bash builtin command)
   program-name-collision /usr/games/true /bin/true
 
 Package: adequate-testpkg-py-file-not-bytecompiled
@@ -72,4 +73,3 @@
 
 Package: adequate-testpkg-symbol-size-mismatch
 Architecture: any
-Description: adequate test package; do not install

## adequate 0.12.1

=== debian/changelog ===
adequate (0.12.1) unstable; urgency=medium

  * Fix “keys/push on reference is experimental” warnings (closes: #758306).
    Thanks to Axel Beckert for the bug report.

 -- Jakub Wilk <jwilk@debian.org>  Sat, 16 Aug 2014 19:07:55 +0200

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,6 @@
 Section: utils
 Priority: optional
 Maintainer: Jakub Wilk <jwilk@debian.org>
-Uploaders: Holger Levsen <holger@debian.org>
 Build-Depends: debhelper (>= 7), dh-buildinfo,
  perl (>= 5.14),
  python3 (>= 3.2), python3-apt

=== debian/rules ===
--- 
+++ 
@@ -1,4 +1,6 @@
 #!/usr/bin/make -f
+
+version = $(word 2,$(shell dpkg-parsechangelog | grep ^Version:))
 
 .PHONY: clean
 clean: doc/Makefile tests/Makefile
@@ -13,7 +15,7 @@
 debian/build-stamp: doc/Makefile adequate
 	$(MAKE) -B -C doc/
 ifeq "$(filter nocheck,$(DEB_BUILD_OPTIONS))" ""
-	./adequate coreutils 2>&1 | ( ! grep . )
+	adt_adequate=./adequate adt_testpkg=coreutils debian/tests/smoke-test
 endif
 	touch $(@)
 
@@ -25,10 +27,14 @@
 	dh_prep
 	dh_installdirs
 	dh_install
+	sed -i \
+		-r -e 's/^(our \$$VERSION) =.*/\1 = "$(version)";/' \
+		debian/*/usr/bin/*
 	dh_installman doc/*.1
 	dh_perl
 	dh_installdocs
 	dh_installchangelogs
+	dh_buildinfo
 	dh_compress
 	dh_fixperms
 	dh_installdeb

## adequate 0.15~bpo8+1

=== debian/changelog ===
adequate (0.15~bpo8+1) jessie-backports; urgency=low

  * Rebuild for jessie-backports.

 -- Jakub Wilk <jwilk@debian.org>  Thu, 15 Oct 2015 23:59:22 +0200

adequate (0.15) unstable; urgency=low

  * Add license information for the Ghostscript library (closes: #795566).
    Thanks to Didier Raboud for the bug report.
  * Add license information for the jbig2dec library.
  * Recognize AGPL-3 in machine-readable copyright files.
  * Add license information for libpoppler.so.46 and libpoppler.so.47.

 -- Jakub Wilk <jwilk@debian.org>  Wed, 26 Aug 2015 11:07:21 +0200

adequate (0.14) unstable; urgency=low

  * Summary of tag changes:
    + Added:
      - ldd-failure

  * Run ldd on each file separately.
  * Don't abort when “ldd -r” fails, but emit ldd-failure instead
    (closes: #762615).

 -- Jakub Wilk <jwilk@debian.org>  Wed, 15 Jul 2015 15:59:36 +0200

adequate (0.13.3) unstable; urgency=low

  * Require pkg-config 0.27 or later in the test suite. In older versions,
    --exists didn't check dependencies.
  * Add pkg-config to Recommends (closes: #787169).
    Thanks to Micah Gersten for the bug report.
  * Exclude VCS-specific files from the source package in
    debian/source/options.

 -- Jakub Wilk <jwilk@debian.org>  Sun, 31 May 2015 18:37:54 +0200

adequate (0.13.2) unstable; urgency=low

  * Drop “XS-Testsuite: autopkgtest”.
  * Add pkg-config to the DEP-8 test Depends (closes: #787043).
    Thanks to Micah Gersten for the bug report.

 -- Jakub Wilk <jwilk@debian.org>  Thu, 28 May 2015 10:42:14 +0200

adequate (0.13.1) unstable; urgency=low

  * Update the package description.
  * Don't emit program-name-collision when one programs symlinks to the
    other.
  * Bump standards version to 3.9.6 (no changes needed).

 -- Jakub Wilk <jwilk@debian.org>  Sun, 10 May 2015 20:15:51 +0200

adequate (0.13) unstable; urgency=low

  * Summary of tag changes:
    + Added:
      - missing-pkgconfig-dependency

  * Check for missing pkg-config dependencies (closes: #781037).
    Thanks to Niels Thykier for the bug report.
  * Fix false positive program-name-collision in debianutils
    (closes: #784068).
  * Improve error handling.

 -- Jakub Wilk <jwilk@debian.org>  Mon, 27 Apr 2015 19:17:57 +0200

## adequate 0.15

=== doc/Makefile ===
--- 
+++ 
@@ -17,4 +17,4 @@
 clean:
 	rm -f adequate.pod *.1 *.tmp
 
-# vim:ts=4 sw=4 noet
+# vim:ts=4 sts=4 sw=4 noet

## adequate 0.15.1~bpo8+1

=== debian/changelog ===
adequate (0.15.1~bpo8+1) jessie-backports; urgency=low

  * Rebuild for jessie-backports.

 -- Jakub Wilk <jwilk@debian.org>  Tue, 01 Mar 2016 12:30:11 +0100

adequate (0.15.1) unstable; urgency=low

  * Fix false positive program-name-collision in less.
  * Use date of last modification in the manual page footer.
    This should help to make the package builds reproducible.
  * Fix typo in a tag description.
  * Add license information for libpoppler.so.57.

 -- Jakub Wilk <jwilk@debian.org>  Tue, 12 Jan 2016 15:34:17 +0100
